'From Squeak 2.2 of Sept 23, 1998 on 9 October 1998 at 7:36:33 pm'!
Object subclass: #Arrow
	instanceVariableNames: 'to weight '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Math-Graph'!
Object subclass: #Edge
	instanceVariableNames: 'from arrow '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Math-Graph'!
Object subclass: #Graph
	instanceVariableNames: 'vertices '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Math-Graph'!
MorphicWrapper subclass: #GraphMorphicWrapper
	instanceVariableNames: 'deltaTotal desiredDistance '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Math-Graph'!
Graph subclass: #SingleEdgedGraph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Math-Graph'!
Object subclass: #Vertex
	instanceVariableNames: 'name arrows '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Math-Graph'!
MorphicWrapper subclass: #VertexMorphicWrapper
	instanceVariableNames: 'dxdy '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Math-Graph'!

!Arrow commentStamp: '<historical>' prior: 0!
my instances represents arrows (to use in a Graph together with Vertex).
an Arrow knows where it's pointing to (it't destination) and also has a value,
this is usefull to assign a value to an arrow in a Graph.

	to create a new Arrow:
		Arrow to: aVertex value: anObject

	when you do: aVertex addArrowTo: aVertex, a new arrow is created and added
		to aVertex's adjacecy list.!

!Arrow methodsFor: 'accessing' stamp: 'r++ 12/7/97 23:53'!
to
	^to! !

!Arrow methodsFor: 'accessing' stamp: 'r++ 12/7/97 23:53'!
to: anObject
	to _ anObject! !

!Arrow methodsFor: 'accessing' stamp: 'r++ 12/7/97 23:58'!
weight
	^weight! !

!Arrow methodsFor: 'accessing' stamp: 'r++ 12/7/97 23:53'!
weight: anObject
	weight _ anObject! !

!Arrow methodsFor: 'printing' stamp: 'r++ 12/7/97 23:59'!
printOn: aStream
	" my printString is -value->to"
	aStream nextPut: $=; nextPut: $=.
	self weight printOn: aStream.
	aStream nextPutAll: '==>'.
	self to name printOn: aStream ! !

!Arrow methodsFor: 'comparing' stamp: 'r++ 12/10/97 03:41'!
= anArrow
	" an Arrow is identfyed by it's destination (to)"
	^ self to = anArrow to! !


!Arrow class methodsFor: 'instance creation' stamp: 'r++ 12/7/97 23:53'!
to: aVertex 
	" public - will create and answer a new Arraw pointing to aVertex with value nil"
	^ self to: aVertex weight: nil! !

!Arrow class methodsFor: 'instance creation' stamp: 'r++ 12/7/97 23:53'!
to: aVertex weight: anObject
	" public - will create and answer a new Arraw pointing to aVertex with value anObject"
	^ self new
		to: aVertex;
		weight: anObject! !


!Edge methodsFor: 'printing' stamp: 'r++ 12/7/97 23:58'!
printOn: aStream
	" my text representation is like an Association's representation"
	self from name printOn: aStream.
	self arrow printOn: aStream! !

!Edge methodsFor: 'accessing' stamp: 'r++ 12/7/97 23:53'!
arrow
	^arrow! !

!Edge methodsFor: 'accessing' stamp: 'r++ 12/7/97 23:53'!
arrow: anObject
	arrow _ anObject! !

!Edge methodsFor: 'accessing' stamp: 'r++ 11/30/97 01:28'!
from
	" public - answer my starting point"
	^ from! !

!Edge methodsFor: 'accessing' stamp: 'r++ 12/7/97 23:53'!
from: anObject
	from _ anObject! !

!Edge methodsFor: 'accessing' stamp: 'r++ 12/7/97 23:53'!
to
	" public - answer my ending point"
	^ self arrow to! !

!Edge methodsFor: 'accessing' stamp: 'r++ 12/7/97 23:53'!
weight
	" public - answer my value"
	^ self arrow weight! !


!Edge class methodsFor: 'instance creation' stamp: 'r++ 12/7/97 23:53'!
from: aVertex arrow: anArrow
	" public - will create and answer a new Edge from aVertex with anArrow leaving it"
	^ self new
		from: aVertex;
		arrow: anArrow! !

!Edge class methodsFor: 'instance creation' stamp: 'r++ 12/7/97 23:53'!
from: aVertex to: bVertex
	" public - will create and answer a new Edge from aVertex to bVertex"
	^ self from: aVertex to: bVertex weight: nil! !

!Edge class methodsFor: 'instance creation' stamp: 'r++ 12/7/97 23:53'!
from: aVertex to: bVertex weight: anObject
	" public - will create and answer a Vertex from aVertex to bVertex with value anObject"
	^ self from: aVertex arrow: (Arrow to: bVertex weight: anObject)! !


!Graph commentStamp: '<historical>' prior: 0!
My instances are Graphs that can be shown in a morphic world.

The graphical representation is achieved by thinking that each pair of nodes is connected
with a contractile or expansive spring, for connected or unconnected nodes, respectively.
This makes connected nodes stay close to each other, and unconnected nodes away.
[not finished yet]
Mis instancias son grafos que pueden ser vistos en un morphic world.

La representacion grafica es lograda pensando que cada par de nodos esta conectado con un resorte contractil o expansivo, dependiendo si los nodos estan conectados o desconectados.
Esto produce que los nodos conectados traten de mantenerse cerca unos de los otros, y que los
desconectados se alejen. [todavia no esta terminado]!

!Graph methodsFor: 'adding - removing' stamp: 'r++ 10/1/1998 01:07'!
addAllVertices: aVerticesCollection
	" public - add aVertex to my vertices"
	aVerticesCollection do: [:eachVertex | self vertices add: eachVertex].
	self updateMorph.
	^ aVerticesCollection! !

!Graph methodsFor: 'adding - removing' stamp: 'r++ 12/10/97 03:07'!
addArcFrom: aVertexOrSymbol to: bVertexOrSymbol
	" public - add an arc from aVertex to bVertex.
	  adds two arrows"
	self addArrowFrom: aVertexOrSymbol to: bVertexOrSymbol.
	self addArrowFrom: bVertexOrSymbol to: aVertexOrSymbol! !

!Graph methodsFor: 'adding - removing' stamp: 'r++ 5/16/1998 18:44'!
addArrowFrom: aVertexOrSymbol to: bVertexOrSymbol
	" public - add an arraw from node whos name is aVertexOrSybol name
	  to node whos name is bVertexOrSymbol"
	self addArrowFrom: aVertexOrSymbol to: bVertexOrSymbol weighted: nil.
	^bVertexOrSymbol! !

!Graph methodsFor: 'adding - removing' stamp: 'r++ 9/4/1998 00:52'!
addArrowFrom: aVertexOrSymbol to: bVertexOrSymbol weighted: anObject
	" public - add an arraw from node whos name is aVertexOrSybol name
	  to node whos name is bVertexOrSymbol with weight anObject"
	(self vertexForNameIfNoneAdd: aVertexOrSymbol)
		addArrowTo: (self vertexForNameIfNoneAdd: bVertexOrSymbol) weight: anObject.
	self updateMorph
! !

!Graph methodsFor: 'adding - removing' stamp: 'r++ 1/17/98 19:30'!
addEdge: anEdge
	" public - add an edge to my edges
	            will add an Arrow to propper vertex"
	self addArrowFrom: anEdge from to: anEdge to weighted: anEdge weight! !

!Graph methodsFor: 'adding - removing' stamp: 'r++ 9/4/1998 00:52'!
addVertex: aVertex
	" public - add aVertex to my vertices"
	self vertices add: aVertex.
	self updateMorph.
	^ aVertex! !

!Graph methodsFor: 'adding - removing' stamp: 'r++ 9/4/1998 00:53'!
removeArrowFrom: aVertexOrSymbol to: bVertexOrSymbol
	" public - remove an arrow from aVertex* to bVertex*"
	(self vertexForName: aVertexOrSymbol) removeArrowTo: bVertexOrSymbol.
	self updateMorph! !

!Graph methodsFor: 'adding - removing' stamp: 'r++ 9/6/1998 05:29'!
removeVertex: aVertex
	" public - add aVertex to my vertices"
	self vertices remove: aVertex ifAbsent: [].
	self updateMorph.
	^ aVertex! !

!Graph methodsFor: 'initialization' stamp: 'r++ 12/7/97 23:53'!
initialize
	self vertices: OrderedCollection new! !

!Graph methodsFor: 'accessing' stamp: 'r++ 12/7/97 23:55'!
edges
	" public - answer aCollection of all my edges"
	| answer |
	answer _ OrderedCollection new.
	self vertices do: [:each | answer addAll: each edges].
	^ answer! !

!Graph methodsFor: 'accessing' stamp: 'r++ 10/1/1998 01:18'!
includes: aVertex
	^ (self vertexForName: aVertex) isNil not! !

!Graph methodsFor: 'accessing' stamp: 'r++ 12/9/97 15:33'!
vertexForName: aVertexOrSymbol 
	" public - answer a node whos name matches aVertexOrSymbol's.
	  If it doesn't exist answer nil"
	^ self vertexForName: aVertexOrSymbol ifNone: [nil]! !

!Graph methodsFor: 'accessing' stamp: 'r++ 12/7/97 23:53'!
vertexForName: aVertexOrSymbol ifNone: aBlock
	" public - answer a node whos name matches aVertexOrSymbol's.
	  If it doesn't exist do aBlock"
	| aVertexName |
	aVertexName _ aVertexOrSymbol name asSymbol.
	^ self vertices
		detect: [:one | one name = aVertexName]
		ifNone: [aBlock value]! !

!Graph methodsFor: 'accessing' stamp: 'r++ 12/9/97 15:30'!
vertexForNameIfNoneAdd: aVertexOrSymbol
	" public - answer a vertex whos name matches aVertexOrSymbol's
	  If it doesn't exist create one (and add myself it)"
	^ self vertexForName: aVertexOrSymbol
		ifNone: [^ self addVertex: (Vertex name: aVertexOrSymbol name asSymbol)]! !

!Graph methodsFor: 'accessing' stamp: 'r++ 12/7/97 23:53'!
vertices
	^vertices! !

!Graph methodsFor: 'accessing' stamp: 'r++ 12/7/97 23:53'!
vertices: anObject
	vertices _ anObject! !

!Graph methodsFor: 'accessing' stamp: 'r++ 10/9/1998 18:30'!
weights
	" public - answer a set with all the wieghts I have"
	| answer |
	answer _ (self edges collect: [:eachArrow | eachArrow weight]).
	answer remove: nil ifAbsent: [].
	^ answer asSet! !

!Graph methodsFor: 'graph functions' stamp: 'r++ 10/1/1998 01:44'!
addSubGraphFor: aVertex to: aGraph
	aVertex arrows do: [:eachArrow |
		(aGraph includes: eachArrow to)
			ifFalse: [
				aGraph addArrowFrom: aVertex to: eachArrow to.
				self addSubGraphFor: eachArrow to to: aGraph]
			ifTrue: [
				aGraph addArrowFrom: aVertex to: eachArrow to]].
	^ aGraph! !

!Graph methodsFor: 'graph functions' stamp: 'r++ 10/1/1998 01:51'!
hasLoop
	self vertices do: [:eachVertex |
		(self hasLoopOn: eachVertex) ifTrue: [^ true]].
	^ false! !

!Graph methodsFor: 'graph functions' stamp: 'r++ 10/1/1998 01:50'!
hasLoopOn: aVertex
	(self vertexForName: aVertex) arrows do: [:eachArrow |
		((self subGraphFor: eachArrow to) includes: aVertex) ifTrue: [^ true]].
	^ false! !

!Graph methodsFor: 'graph functions' stamp: 'r++ 12/12/97 02:40'!
squared
	" public - answer a new Graph wich is my squared graph.
	  That's a new Graph whos edges are (a,c) if and only if
	  I have an edge (a,b) and an edge (b,c) for some node b.
		This notion can be extended to multilpication of Graphs, see #*"
	| answer |
	answer _ self class new.
	self edges do: [:eachEdge |
		eachEdge to adjacentVertices do: [:eachTherd |
					answer addArrowFrom: eachEdge from to: eachTherd]].
	^ answer! !

!Graph methodsFor: 'graph functions' stamp: 'r++ 10/1/1998 01:39'!
subGraphFor: aVertex
	| answer |
	answer _ self class new.
	^ self addSubGraphFor: (self vertexForName: aVertex) to: answer.
! !

!Graph methodsFor: 'graph functions' stamp: 'r++ 1/17/98 19:30'!
transposed
	" public - answer my transposed Graph.
	  see [ALG] Exercise 23.1-3.
		The running time of this implementation is O(V+E),
		more accurate, it's O(V+(c1*E+c2*E) as edges (arrows) are walked once to answer
		#edges (c1), and once again to add each reversed Edge (c2).
		An implementation of an O(V+c*E) algorithm (as insinuated in [ALG])
		requires to add reversed Edges at same time than collecting edges, but this
		breakes out factorization, how ever, the total running time is the same (c=c1+c2),
		as all operations performed in one implementation should be implemented in the
		other (you have to ADD each new edge, COLLET each edge and WALK each vertex)"
	| answer |
	answer _ self class new.
	self edges do: [:eachEdge |
		answer addArrowFrom: eachEdge to to: eachEdge from weighted: eachEdge weight].
	^ answer! !

!Graph methodsFor: 'converting' stamp: 'r++ 9/18/1998 22:12'!
asMatrix
	| answer |
	answer _ (Smalltalk at: #Matrix) zeros: self vertices size.
	1 to: self vertices size do: [:each |
		(self vertices at: each) adjacentVertices do: [:eachVertex |
			answer at: each@(self vertices indexOf: eachVertex) put: 1]].
	^ answer! !

!Graph methodsFor: 'converting' stamp: 'r++ 12/10/97 03:45'!
asSingleEdgeGraph
	" public - answer a new SingleEdgeGraph with same edges as myself"
	^ SingleEdgeGraph fromGraph: self! !

!Graph methodsFor: 'converting' stamp: 'r++ 8/26/1998 19:34'!
morphicWrapperClass
	^ Smalltalk at: #GraphMorphicWrapper! !

!Graph methodsFor: 'testing' stamp: 'r++ 12/10/97 03:59'!
hasArrowFrom: aVertexOrSymbol to: bVertexOrSymbol
	" public - answer whether I have an arrow from aVertexOrSymbol to bVertexOrSymbol"
	^ (self hasVertex: (aVertexOrSymbol)) and: [
		(self vertexForName: aVertexOrSymbol) hasAnArrowTo: bVertexOrSymbol]! !

!Graph methodsFor: 'testing' stamp: 'r++ 12/10/97 04:01'!
hasVertex: aVertexOrSymbol
	" public - answer whether I have the Vertex aVertexOrSymbol"
	^ (self vertexForName: aVertexOrSymbol) isNil not! !

!Graph methodsFor: 'printing' stamp: 'r++ 12/7/97 23:53'!
printOn: aStream
	" my printString is a list of all my vertices and their adjacencyList"
	self vertices do: [:each |
		each printOn: aStream. 
		aStream cr]! !


!Graph class methodsFor: 'instance creation' stamp: 'r++ 10/4/1998 22:27'!
for: anObject 
	^ self for: anObject depth: -1! !

!Graph class methodsFor: 'instance creation' stamp: 'r++ 10/4/1998 20:47'!
for: anObject depth: anInteger
	^ self for: anObject depth: anInteger addTo: (self new)! !

!Graph class methodsFor: 'instance creation' stamp: 'r++ 10/4/1998 20:48'!
for: anObject depth: anInteger addTo: aGraph
	| objectName |
	anInteger = 0 ifFalse: [
		objectName _ anObject name asSymbol.
		(self subpartsOf: anObject) do: [:each |
			aGraph addArrowFrom: objectName to: each name asSymbol.
			self for: each depth: anInteger - 1 addTo: aGraph]].
	^ aGraph
! !

!Graph class methodsFor: 'instance creation' stamp: 'r++ 10/2/1998 00:53'!
hierarchyOf: anObject
	| answer object |
	answer _ self new.
	object _ anObject.
	[object superclass isNil] whileFalse: [
		answer addArrowFrom: object superclass name asSymbol to: object name asSymbol.
		object _ object superclass].
	^ self hierarchyOf: anObject addTo: answer! !

!Graph class methodsFor: 'instance creation' stamp: 'r++ 10/2/1998 00:42'!
hierarchyOf: anObject addTo: aGraph
	| objectName |
	objectName _ anObject name asSymbol.
	anObject subclasses do: [:eachSubclass |
		aGraph addArrowFrom: objectName to: eachSubclass name asSymbol.
		self hierarchyOf: eachSubclass addTo: aGraph].
	^ aGraph! !

!Graph class methodsFor: 'instance creation' stamp: 'r++ 11/30/97 01:23'!
new
	^ super new initialize! !

!Graph class methodsFor: 'instance creation' stamp: 'r++ 10/3/1998 01:40'!
subpartsOf: anObject
	| subparts |
	subparts _ OrderedCollection new.
	1 to: anObject class instSize do: [ :each | subparts add: (anObject instVarAt: each)].
	1 to: anObject basicSize do: [ :each | subparts add: (anObject basicAt: each)].
	^ subparts! !


!GraphMorphicWrapper commentStamp: '<historical>' prior: 0!
My instances are Graphs that can be shown in a morphic world.

The graphical representation is achieved by thinking that each pair of nodes is connected
with a contractile or expansive spring, for connected or unconnected nodes, respectively.
This makes connected nodes stay close to each other, and unconnected nodes away.
[not finished yet]
Mis instancias son grafos que pueden ser vistos en un morphic world.

La representacion grafica es lograda pensando que cada par de nodos esta conectado con un resorte contractil o expansivo, dependiendo si los nodos estan conectados o desconectados.
Esto produce que los nodos conectados traten de mantenerse cerca unos de los otros, y que los
desconectados se alejen. [todavia no esta terminado]!

!GraphMorphicWrapper methodsFor: 'initialization' stamp: 'r++ 10/4/1998 20:45'!
initialize
	super initialize.
	desiredDistance _ 40.! !

!GraphMorphicWrapper methodsFor: 'accesing' stamp: 'r++ 12/12/97 04:05'!
desiredDistance
	" answer the distance I like to be my vertices"
	^ desiredDistance! !

!GraphMorphicWrapper methodsFor: 'accesing' stamp: 'r++ 10/4/1998 20:41'!
desiredDistance: anInteger
	" set the distance I like to be my vertices"
	desiredDistance _ anInteger.
	self updateContents! !

!GraphMorphicWrapper methodsFor: 'drawing' stamp: 'r++ 10/9/1998 18:10'!
drawOn: aCanvas
	" draw edges"
	| to |
	super drawOn: aCanvas.
	self object edges do: [:eachEdge |
		aCanvas
			line: eachEdge from asMorph center
			to: (to _ eachEdge to asMorph center)
			width: 1
			color: Color red.
"		aCanvas					""This lines draw arrow's head""
			fillOval: ((to -(10@3)) corner: (to + 3))
			color: Color red"].
! !

!GraphMorphicWrapper methodsFor: 'event handling' stamp: 'r++ 9/6/1998 05:46'!
aboutToRemove: aMorph
	self object removeVertex: aMorph object.! !

!GraphMorphicWrapper methodsFor: 'event handling' stamp: 'r++ 9/6/1998 05:46'!
acceptDroppingMorph: aMorph event: evt
	" if it's a Vertex, just accept it... this is to allow vertices rearranging. It have to be diferent"
	(aMorph isKindOf: VertexMorphicWrapper) ifTrue: [
		self object addVertex: aMorph object.
		aMorph dxdy: 0@0.
		self addMorph: aMorph.
		^ self startStepping.].
	^ super acceptDroppingMorph: aMorph event: evt.
! !

!GraphMorphicWrapper methodsFor: 'event handling' stamp: 'r++ 10/4/1998 22:21'!
addCustomMenuItems: aCustomMenu hand: aHandMorph
	"r++ 5/16/1998 19:02
		added startStepping"
	super addCustomMenuItems: aCustomMenu hand: aHandMorph.
	aCustomMenu
		addLine;
		add: 'shuffle' action: #shuffle! !

!GraphMorphicWrapper methodsFor: 'event handling' stamp: 'r++ 9/6/1998 05:48'!
allowSubmorphExtraction
	" allow extraction so submorphs can be grabbed and dragged to a new position.
	  usefull to rearrange the vertices manually"
	^ true! !

!GraphMorphicWrapper methodsFor: 'event handling' stamp: 'r++ 10/4/1998 22:20'!
shuffle
	" random move all submorphs"
	self submorphs do: [:eachMorph |
		eachMorph dxdy: 101 atRandom@101 atRandom - 50].
	self startStepping! !

!GraphMorphicWrapper methodsFor: 'stepping' stamp: 'r++ 9/4/1998 00:33'!
aproachConnectedNodes
	" connected nodes are tied with a rubber band', they aproach each other"
	| len f from to |
	self edges do: [:eachArc |
		from _ eachArc from asMorph.
		to _ eachArc to asMorph.
		(len _ (from center - to center) r) = 0 ifFalse: [
			f _ (self desiredDistance - len) asFloat / (len * 4).
			to dxdy: to dxdy - (from center - to center * f).
			from dxdy: from dxdy +  (from center - to center * f)]]! !

!GraphMorphicWrapper methodsFor: 'stepping' stamp: 'r++ 9/4/1998 01:19'!
separateAllNodesAndCenter
	" will set dxdy of each node according to the computation of the separation.
	  the graph is centered in my bounds"
	| dxdy c1 c2 inBounds |
	inBounds _ (self submorphs at: 1 ifAbsent: [^ self]) center.
	inBounds _ inBounds corner: inBounds.
	self vertices do: [:node1 |
		dxdy _ 0@0.
		inBounds _ inBounds encompass: (c1 _ node1 asMorph center).
		self vertices do: [:node2 |
			c2 _ node2 asMorph center.
			(node1 == node2 or: [(c1 - c2) r > 80]) ifFalse: [
				c1 = c2
					ifTrue: [dxdy _ dxdy + (3 atRandom@3 atRandom)]
					ifFalse: [dxdy _ dxdy + ((c1 - c2) / (c1 - c2) r squared)]]].
		dxdy r > 0 ifTrue: [
			node1 asMorph dxdy: (node1 asMorph dxdy + (dxdy / dxdy r * 2) min: 10@10)]].
	self vertices do: [:each | "center"
		each asMorph dxdy: each asMorph dxdy - inBounds center + self bounds center].
	self bounds: (inBounds expandBy: 5).
! !

!GraphMorphicWrapper methodsFor: 'stepping' stamp: 'r++ 10/9/1998 18:08'!
step
	" will calculate a new position for every submorph, based on gravitanional low.
	  it's not working as desired, must be changed for some other aproach"
	deltaTotal _ 0.
	self vertices do: [:eachVertex |
		(self submorphs includes: eachVertex asMorph) ifFalse: [
			eachVertex asMorph position: self center.
			self addMorph: eachVertex asMorph]].
	self aproachConnectedNodes; separateAllNodesAndCenter.
	self vertices do: [:each |
		deltaTotal _ deltaTotal max: each asMorph doMove.
		each asMorph dxdy: each asMorph dxdy / 2].
	deltaTotal < 0.5 ifTrue: [self stopStepping].
	self changed	! !

!GraphMorphicWrapper methodsFor: 'stepping' stamp: 'r++ 5/17/1998 01:24'!
stepTime
	"r++ 12/25/97 00:07
	as fast as possible"
	^ 0		! !

!GraphMorphicWrapper methodsFor: 'stepping' stamp: 'r++ 10/4/1998 19:55'!
updateContents
	self startStepping! !

!GraphMorphicWrapper methodsFor: 'delegation' stamp: 'r++ 12/12/97 02:45'!
edges
	^ self object edges! !

!GraphMorphicWrapper methodsFor: 'delegation' stamp: 'r++ 9/4/1998 00:42'!
vertices
	^ self object vertices! !


!SingleEdgedGraph methodsFor: 'adding' stamp: 'r++ 10/3/1998 01:53'!
addArrowFrom: aVertexOrSymbol to: bVertexOrSymbol
	" public - will add myself an arrow from aVertex to bVertex only if I don't already have it"
	(self hasArrowFrom: aVertexOrSymbol to: bVertexOrSymbol)
		ifFalse: [super addArrowFrom: aVertexOrSymbol to: bVertexOrSymbol]! !


!SingleEdgedGraph class reorganize!
('as yet unclassified')
!


!Vertex methodsFor: 'initialization' stamp: 'r++ 12/10/97 02:55'!
initialize
	" my adjacencyList will be an OrderedCollection"
	arrows _ OrderedCollection new! !

!Vertex methodsFor: 'initialization' stamp: 'r++ 9/4/1998 00:32'!
morphicWrapperClass
	^ Smalltalk at: #VertexMorphicWrapper! !

!Vertex methodsFor: 'accessing' stamp: 'r++ 12/10/97 02:56'!
adjacentVertices
	" public - answer all the verteces I have in my adjacencyList"
	^ self arrows collect: [:each | each to]! !

!Vertex methodsFor: 'accessing' stamp: 'r++ 12/10/97 02:57'!
arrows
	^arrows! !

!Vertex methodsFor: 'accessing' stamp: 'r++ 12/7/97 23:53'!
name
	"answer my name"
	^ name! !

!Vertex methodsFor: 'accessing' stamp: 'r++ 12/7/97 23:53'!
name: aSymbol
	"set my name"
	name _ aSymbol! !

!Vertex methodsFor: 'adding - removing' stamp: 'r++ 12/10/97 03:49'!
addArrowTo: aVertex
	" public - will add an Edge from myself to aVertex to my adjacency list"
	self addArrowTo: aVertex weight: nil! !

!Vertex methodsFor: 'adding - removing' stamp: 'r++ 12/10/97 03:48'!
addArrowTo: aVertex weight: anObject
	" public - will add an Edge from myself to aVertex with weight anObject to my adjacency list"
	self arrows add: (Arrow to: aVertex weight: anObject)! !

!Vertex methodsFor: 'adding - removing' stamp: 'r++ 12/10/97 03:39'!
removeArrowTo: aVertexOrSymbol
	" public - remove the Arrow to aVertex* from my arrows, if it exists"
	self arrows
		remove: (Arrow to: (Vertex name: aVertexOrSymbol name asSymbol)) ifAbsent: [nil]! !

!Vertex methodsFor: 'comparing' stamp: 'r++ 3/28/98 17:39'!
= aVertex
	" public - Vertices are identified by its name"
	^ self name asSymbol = aVertex name asSymbol! !

!Vertex methodsFor: 'printing' stamp: 'r++ 12/10/97 02:59'!
printOn: aStream
	"my text representation is my name followed of my adjacecyList"
	self name printOn: aStream.
	aStream space; nextPut: $(.
	self adjacentVertices do: [:each |
		each name printOn: aStream.
		aStream space].
	aStream nextPut: $)! !

!Vertex methodsFor: 'vertex functions' stamp: 'r++ 12/10/97 02:56'!
edges
	" public - answer a Collection of all the edges that coneccts me with my adjacent nodes"
	^ self arrows collect: [:each | Edge from: self arrow: each] ! !

!Vertex methodsFor: 'vertex functions' stamp: 'r++ 12/10/97 03:17'!
hasAnArrowTo: aVertexOrSymbol
	" public - answer whether I have an arrow to aVertexOrSymbol or not"
	^ self adjacentVertices includes: (Vertex name: aVertexOrSymbol name asSymbol)! !


!Vertex class methodsFor: 'instance creation' stamp: 'r++ 12/10/97 03:38'!
name: aSymbol
	" creates and answers a new Vertex whos name is aSymbol"
	^ self new name: aSymbol! !

!Vertex class methodsFor: 'instance creation' stamp: 'r++ 12/7/97 23:53'!
new
	^ super new initialize! !


!VertexMorphicWrapper methodsFor: 'drawing' stamp: 'r++ 12/12/97 03:26'!
drawOn: aCanvas
	" my visual representation is an ellipse and my name"
	| scanner |
	scanner _ QuickPrint new.
	self extent: (scanner stringWidth: self object name printString) @ (scanner lineHeight).
	aCanvas fillOval: self bounds color: Color yellow.
	aCanvas text: self object name printString bounds: self bounds font: nil color: Color black! !

!VertexMorphicWrapper methodsFor: 'initialization' stamp: 'r++ 12/12/97 03:33'!
initialize
	super initialize.
	self dxdy: 0@0! !

!VertexMorphicWrapper methodsFor: 'initialization' stamp: 'r++ 12/12/97 02:25'!
morphicWrapperClass
	^ VertexMorphicWrapper! !

!VertexMorphicWrapper methodsFor: 'stepping' stamp: 'r++ 4/25/98 21:05'!
doMove
	" move my by dxdy, this is done becouse to move me, I have to wait till all other vertices
	are allready moved, this is done in to step: first set delta X and delta Y, then perform the
	actual move"
	self privateMoveBy: self dxdy.
	^ self dxdy r.! !

!VertexMorphicWrapper methodsFor: 'stepping' stamp: 'r++ 10/4/1998 19:56'!
updateContents
	self changed! !

!VertexMorphicWrapper methodsFor: 'accessing' stamp: 'r++ 12/12/97 03:30'!
dxdy
	^dxdy! !

!VertexMorphicWrapper methodsFor: 'accessing' stamp: 'r++ 12/12/97 03:32'!
dxdy: anObject
	dxdy _ anObject! !


